mod_firstSeenBeat = GAMESTATE:GetSongBeat() --necessary to prevent long freezes
local checked = false
local curaction = 1
prefix_globals = {}

-- PLAYERS & JUDCOM PROXIES --
--Holds the Player actors, NoteField actors and NoteField wrapper states, if you need them.
local mod_plr = {nil,nil}
local mod_nfd = {nil,nil}
local mod_nfdwrap = {nil,nil}

--this is both a message broadcaster and a function runner
--if you put {beat,'String'}, then 'String' is broadcast as a message on that beat
--if you put {beat,function() somecode end}, then function() is run at that beat

--{beat,thing,persists}
prefix_globals.actions = {
	{246.5,'HideMS'},
	{280,'ShowBSOD'},
	{281,'ShowMS'},
	{283,'ForSongEnd',true},
}

-- UPDATE FUNCTION --
--This is where the readers are run.
local disable = false;
local function DoUpdate()
	local beat = GAMESTATE:GetSongBeat()

---------------------------------------------------------------------------------------
----------------------Begin table handlers---------------------------------------------
---------------------------------------------------------------------------------------

	if disable ~= true and checked then
		if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --

			---------------------------------------
			-- Actions table --
			---------------------------------------
			while curaction<=table.getn(prefix_globals.actions) and GAMESTATE:GetSongBeat()>=prefix_globals.actions[curaction][1] do
				if prefix_globals.actions[curaction][3] or GAMESTATE:GetSongBeat() < prefix_globals.actions[curaction][1]+2 then
					if type(prefix_globals.actions[curaction][2]) == 'function' then
						prefix_globals.actions[curaction][2]()
					elseif type(prefix_globals.actions[curaction][2]) == 'string' then
						MESSAGEMAN:Broadcast(prefix_globals.actions[curaction][2]);
					end
				end
				curaction = curaction+1;
			end
			
		end
	end
end

return Def.ActorFrame{
	InitCommand= function(self)
---------------------------------------------------------------------------------------
----------------------Sort the actions table-------------------------------------------
---------------------------------------------------------------------------------------

		local function modtable_compare(a,b)
			return a[1] < b[1]
		end

		if table.getn(prefix_globals.actions) > 1 then
			table.sort(prefix_globals.actions, modtable_compare)
		end
	end,
	Def.Actor{OnCommand=function(s) s:sleep(9e9) end},
	Def.ActorFrame{
		OnCommand= function(self)
			self:queuecommand('BeginUpdate')
		end,
		BeginUpdateCommand= function(self)
			local beat = GAMESTATE:GetSongBeat()
			if beat>=0 and not checked then
				for pn=1,2 do
					_G['P'..pn] = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn) or nil;
					if _G['P'..pn] then
						mod_plr[pn] = _G['P'..pn]
						mod_nfd[pn] = _G['P'..pn]:GetChild('NoteField')
						if _G['P'..pn]:GetChild('NoteField'):GetNumWrapperStates() == 0 then
							_G['P'..pn]:GetChild('NoteField'):AddWrapperState()
						end
						mod_nfdwrap[pn] = _G['P'..pn]:GetChild('NoteField'):GetWrapperState(1)
					end
				end
				checked = true;
			end
			if checked then self:SetUpdateFunction(DoUpdate)
			else self:sleep(0.1):queuecommand('BeginUpdate') end
		end,
	},

	Def.ActorFrameTexture {
		Name = 'BackAFT',
		InitCommand = function(self)
			BackAFT = self
		end,
		ProxyCommand = function(self)
			self
				:SetSize(SCREEN_WIDTH, SCREEN_HEIGHT)
				:EnableDepthBuffer(false)
				:EnableAlphaBuffer(true)
				:EnableFloat(false)
				:EnablePreserveTexture(false)
				:Create()
		end,
		HideMSMessageCommand = function(self)
			self:visible(false)
		end,
		ShowMSMessageCommand = function(self)
			self:visible(true)
		end,
		OnCommand = function(self)
			self:sleep(95.835)
			self:queuecommand('Proxy')
		end,
		
		Def.Sprite {
			Name = 'BackSprite',
			OnCommand = function(self)
				BackSprite = self
				self:sleep(95.835)
				self:queuecommand('Proxy')
			end,
			ProxyCommand = function(self)
				self
					:Center()
					:SetTexture(BackAFT:GetTexture())
					:diffusealpha(0)
			end,
		},

		Def.ActorProxy {
			Name = 'ProxyUnderlay',
			ProxyCommand = function(self)
				if SCREENMAN:GetTopScreen():GetChild('Underlay') then
					self:SetTarget(SCREENMAN:GetTopScreen():GetChild('Underlay'))
					SCREENMAN:GetTopScreen():GetChild('Underlay'):visible(false)
				else
					self:visible(false)
				end
			end,
			OnCommand = function(self)
				self:sleep(95.835)
				self:queuecommand('Proxy')
			end,
			ForSongEndMessageCommand = function(self)
				if SCREENMAN:GetTopScreen():GetChild('Underlay') then
					SCREENMAN:GetTopScreen():GetChild('Underlay'):visible(true)
				else
					self:visible(true)
				end
			end,
		},

		Def.ActorProxy { 
			Name = 'ProxyP1',
			ProxyCommand = function(self)
				if P1 then
					self:SetTarget(P1)
					P1:visible(false)
				else
					self:visible(false)
				end
			end,
			OnCommand = function(self)
				self:sleep(95.835)
				self:queuecommand('Proxy')
			end,
			ForSongEndMessageCommand = function(self)
				self:visible(true)
				P1:visible(true)
			end,
		},

		Def.ActorProxy {
			Name = 'ProxyP2',
			ProxyCommand = function(self)
				if P2 then
					self:SetTarget(P2)
					P2:visible(false)
				else
					self:visible(false)
				end
			end,
			OnCommand = function(self)
				self:sleep(95.835)
				self:queuecommand('Proxy')
			end,
			ForSongEndMessageCommand = function(self)
				self:visible(true)
				P2:visible(true)
			end,
		},

		Def.ActorProxy {
			Name = 'ProxyOverlay',
			ProxyCommand = function(self)
				if SCREENMAN:GetTopScreen():GetChild('Overlay') then
					self:SetTarget(SCREENMAN:GetTopScreen():GetChild('Overlay'))
					SCREENMAN:GetTopScreen():GetChild('Overlay'):visible(false)
				else
					self:visible(false)
				end
			end,
			OnCommand = function(self)
				self:sleep(95.835)
				self:queuecommand('Proxy')
			end,
			ForSongEndMessageCommand = function(self)
				if SCREENMAN:GetTopScreen():GetChild('Overlay') then
					SCREENMAN:GetTopScreen():GetChild('Overlay'):visible(true)
				else
					self:visible(true)
				end
			end,
		},
	},

	Def.ActorFrameTexture {
		Name = 'MainAFT',
		ProxyCommand = function(self)
			MainAFT = self
			self
				:SetSize(SCREEN_WIDTH, SCREEN_HEIGHT)
				:EnableDepthBuffer(false)
				:EnableAlphaBuffer(false)
				:EnableFloat(false)
				:EnablePreserveTexture(false)
				:Create()
		end,
		ForSongEndMessageCommand = function(self)
			self:visible(false)
		end,
		OnCommand = function(self)
			self:sleep(95.835)
			self:queuecommand('Proxy')
		end,
		Def.Sprite {
			Name = 'MainSprite',
			ProxyCommand = function(self)
				self
					:Center()
					:SetTexture(BackAFT:GetTexture())
					:diffusealpha(1)
			end,
			ForSongEndMessageCommand = function(self)
				self:visible(false)
			end,
			OnCommand = function(self)
				self:sleep(95.835)
				self:queuecommand('Proxy')
			end,
		}
	},

	Def.Sprite {
		Name = 'ShowScreen',
		ProxyCommand = function(self)
			self
				:Center()
				:SetTexture(MainAFT:GetTexture())
		end,
		ForSongEndMessageCommand = function(self)
			self:visible(false)
		end,
		OnCommand = function(self)
			self:sleep(95.835)
			self:queuecommand('Proxy')
		end,
	},

	Def.Sprite { Texture = "bsod-1.png", Name = "bsod",
	OnCommand = function(self)
		self:diffusealpha(0)
		self:x(SCREEN_CENTER_X)
		self:y(SCREEN_CENTER_Y)
		self:stretchto(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT)
	end,

	ShowBSODMessageCommand = function(self)
		self:diffusealpha(1)
		self:sleep(1.5)
		self:linear(1)
		self:diffusealpha(0)
	end},

	Def.Sprite { Texture = "bsod-2.png", Name = "bsod",
	OnCommand = function(self)
		self:diffusealpha(0)
		self:x(SCREEN_CENTER_X)
		self:y(SCREEN_CENTER_Y)
		self:stretchto(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT)
	end,

	ShowBSODMessageCommand = function(self)
		self:sleep(0.1)
		self:diffusealpha(1)
		self:sleep(1.4)
		self:linear(1)
		self:diffusealpha(0)
	end},

	Def.Sprite { Texture = "bsod-3.png", Name = "bsod",
	OnCommand = function(self)
		self:diffusealpha(0)
		self:x(SCREEN_CENTER_X)
		self:y(SCREEN_CENTER_Y)
		self:stretchto(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT)
	end,

	ShowBSODMessageCommand = function(self)
		self:sleep(0.2)
		self:diffusealpha(1)
		self:sleep(1.3)
		self:linear(1)
		self:diffusealpha(0)
	end}
}